/* IMPORTANT:  s necessari connectar-se amb un usuari amb privilegis d'administrador            */
/*             per executar aquest script. Segons les recomanacions del tutorial d'installaci   */
/*             d'Oracle proporcionat per la UOC, Usuari: SYSTEM Password: 1234                                            */
/*             Si tot va correctament, es crear l'espai de taules GUILD_DATA i                   */
/*             l'usuari MOLIVERBES amb password SECRET.                                           */


/*****************************************************************/
/*            Creaci de l'Espai de Taules                       */
/*****************************************************************/

CREATE TABLESPACE GUILD_DATA
	DATAFILE 'C:/oraclexe/app/oracle/oradata/XE/guild_data.dbf' SIZE 100M
	EXTENT MANAGEMENT LOCAL
	SEGMENT SPACE MANAGEMENT AUTO;


/*****************************************************************/
/*             Creaci de l'Usuari de la BD                      */
/*****************************************************************/



CREATE USER MOLIVERBES IDENTIFIED BY SECRET
	DEFAULT TABLESPACE guild_data
	QUOTA UNLIMITED ON guild_data
	TEMPORARY TABLESPACE Temp;

/*****************************************************************/
/*         Assignaci de Privilegis a l'Usuari                    */
/*****************************************************************/

GRANT CREATE SESSION, CREATE TABLE, CREATE SEQUENCE, CREATE TRIGGER, CREATE PROCEDURE TO MOLIVERBES;