/* IMPORTANT: s necessari estar connectat amb l'usuari MOLIVERBES amb password SECRET */
/*            abans d'executar aquest script                                           */

/*****************************************************************************/
/*****************************************************************************/
/*                          ELIMINACI DE LES TAULES                         */
/*****************************************************************************/
/*****************************************************************************/

DROP TABLE MOLIVERBES.ALGORITME CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.T_ANY CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.T_MES CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.POBLACIO CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.TIPUSSERVEI CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.CATEGORIA CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.PERFIL CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.EMPRESA CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.COLABORADOR CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.EMPRESATIPUSSERVEI CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.VALORACIOCOLABORADORS CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.LOG CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.DADES_EMPRESA_MES CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.DADES_POBLACIO_ANY CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.DADES_POBLACIO_MES CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.DADES_COLAB_EMPRESA CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.DADES_COLAB_EMPRESA_MES CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.DADES_PERFIL_EMPRESA_MES CASCADE CONSTRAINTS;
DROP TABLE MOLIVERBES.DADES_PERFIL_MES CASCADE CONSTRAINTS; 
/

/*****************************************************************************/
/*****************************************************************************/
/*                         ELIMINACIO DE SEQNCIES                          */
/*****************************************************************************/
/*****************************************************************************/

DROP SEQUENCE SEQ_POBLACIO;
DROP SEQUENCE SEQ_TIPUSSERVEI;
DROP SEQUENCE SEQ_CATEGORIA;
DROP SEQUENCE SEQ_EMPRESA;
DROP SEQUENCE SEQ_COLABORADOR;
DROP SEQUENCE SEQ_ALGORITME;
DROP SEQUENCE SEQ_LOG;
DROP SEQUENCE SEQ_ANY;
DROP SEQUENCE SEQ_MES;
DROP SEQUENCE SEQ_VALORACIO;

/

/*****************************************************************************/
/*****************************************************************************/
/*                          CREACI DE TAULES                                */
/*****************************************************************************/
/*****************************************************************************/


/*****************************************************************************/
/********************** 1) CREACIO DE TAULA: ALGORITME ***********************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.ALGORITME
(
  IDALGORITME	  INTEGER		      NOT NULL,
  ALGORITME	    NVARCHAR2(100)	NOT NULL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX MOLIVERBES.IDX_ALGORITME ON MOLIVERBES.ALGORITME
(IDALGORITME)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE MOLIVERBES.ALGORITME ADD (
  CONSTRAINT ALGORITME_PK
  PRIMARY KEY
  (IDALGORITME)
  USING INDEX MOLIVERBES.IDX_ALGORITME
  ENABLE VALIDATE);

/

/*****************************************************************************/
/********************  2) CREACIO DE TAULA: T_ANY ****************************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.T_ANY
(
  IDANY		INTEGER		    NOT NULL,
  ANNY		NUMBER(4,0)	  NOT NULL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

CREATE UNIQUE INDEX MOLIVERBES.IDX_ANY ON MOLIVERBES.T_ANY
(IDANY)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE MOLIVERBES.T_ANY ADD (
  CONSTRAINT T_ANY_PK  
  PRIMARY KEY
  (IDANY)
  USING INDEX MOLIVERBES.IDX_ANY ENABLE VALIDATE);

/

/*****************************************************************************/
/******************** 3) CREACIO DE TAULA: T_MES ****************************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.T_MES
(
  IDMES		      INTEGER		                    NOT NULL,
  MES		        NUMBER(2,0)	                  NOT NULL,
  IDANY		      INTEGER		                    NOT NULL,
  IDALGORITME	  INTEGER,
  ESTAT		      CHAR (1 CHAR)	   DEFAULT 'N'	NOT NULL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

CREATE UNIQUE INDEX MOLIVERBES.IDX_MES ON MOLIVERBES.T_MES
(IDMES)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE MOLIVERBES.T_MES ADD (
  CONSTRAINT T_MES_PK  
  PRIMARY KEY
  (IDMES)
  USING INDEX MOLIVERBES.IDX_MES
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.T_MES ADD (
  CONSTRAINT MES_FK1
  FOREIGN KEY (IDANY) 
  REFERENCES MOLIVERBES.T_ANY (IDANY)
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.T_MES ADD (
  CONSTRAINT MES_FK2
  FOREIGN KEY (IDALGORITME) 
  REFERENCES MOLIVERBES.ALGORITME (IDALGORITME)
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.T_MES ADD (
  CONSTRAINT ESTAT_VALID
  CHECK (ESTAT IN ('S', 'N'))
  ENABLE VALIDATE);
/

/*****************************************************************************/
/******************** 4) CREACIO DE TAULA: POBLACIO **************************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.POBLACIO
(
  IDPOBLACIO   INTEGER          NOT NULL,
  POBLACIO     NVARCHAR2(30)    NOT NULL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX MOLIVERBES.IDX_POBLACIO ON MOLIVERBES.POBLACIO
(IDPOBLACIO)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE MOLIVERBES.POBLACIO ADD (
  CONSTRAINT POBLACIO_PK
  PRIMARY KEY
  (IDPOBLACIO)
  USING INDEX MOLIVERBES.IDX_POBLACIO
  ENABLE VALIDATE);
/

/*****************************************************************************/
/******************** 5) CREACIO DE TAULA: TIPUSSERVEI ************************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.TIPUSSERVEI
(
  IDTIPUSSERVEI	INTEGER		                  NOT NULL,
  TIPUS		      NVARCHAR2(20)	              NOT NULL,
  DATA_CREACIO	INTEGER		                  NOT NULL,
  VIGENCIA	    CHAR(1 CHAR)	DEFAULT 'S'		NOT NULL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX MOLIVERBES.IDX_TIPUSSERVEI ON MOLIVERBES.TIPUSSERVEI
(IDTIPUSSERVEI)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE MOLIVERBES.TIPUSSERVEI ADD (
  CONSTRAINT TIPUSSERVEI_PK
  PRIMARY KEY
  (IDTIPUSSERVEI)
  USING INDEX MOLIVERBES.IDX_TIPUSSERVEI
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.TIPUSSERVEI ADD (
  CONSTRAINT TIPUSSERVEI_FK1 
  FOREIGN KEY (DATA_CREACIO) 
  REFERENCES MOLIVERBES.T_MES (IDMES)
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.TIPUSSERVEI ADD (
  CONSTRAINT VIGENCIA_VALIDA
  CHECK (VIGENCIA IN ('S','N'))
  ENABLE VALIDATE);

/

/*****************************************************************************/
/******************** 6) CREACIO DE TAULA: CATEGORIA *************************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.CATEGORIA
(
  IDCATEGORIA   INTEGER		                   NOT NULL,
  CATEGORIA     NVARCHAR2(25)	               NOT NULL,
  RANG		      INTEGER		    DEFAULT 0	     NOT NULL,
  PUNTS		      INTEGER   	  DEFAULT 0      NOT NULL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX MOLIVERBES.IDX_CATEGORIA ON MOLIVERBES.CATEGORIA
(IDCATEGORIA)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE MOLIVERBES.CATEGORIA ADD (
  CONSTRAINT CATEGORIA_PK
  PRIMARY KEY
  (IDCATEGORIA)
  USING INDEX MOLIVERBES.IDX_CATEGORIA
  ENABLE VALIDATE);
/

/*****************************************************************************/
/******************** 7) CREACIO DE TAULA: PERFIL ****************************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.PERFIL
(
  IDPERFIL	CHAR(1 CHAR)		           NOT NULL,
  DESCRIP	  NVARCHAR2(20),
  SUMA		  FLOAT     		DEFAULT 0	   NOT NULL,
  NUMVALS	  INTEGER			  DEFAULT 0,
  MITJA		  FLOAT		      GENERATED ALWAYS AS (
						              CASE WHEN NUMVALS <> 0
       						           THEN SUMA/NUMVALS
       						           ELSE 0
     						          END)	VIRTUAL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX MOLIVERBES.IDX_PERFIL ON MOLIVERBES.PERFIL
(IDPERFIL)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE MOLIVERBES.PERFIL ADD (
  CONSTRAINT PERFIL_PK
  PRIMARY KEY
  (IDPERFIL)
  USING INDEX MOLIVERBES.IDX_PERFIL
  ENABLE VALIDATE);

/

/*****************************************************************************/
/****************** 8) CREACI DE TAULA: EMPRESA       ***********************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.EMPRESA
(
  IDEMPRESA	      INTEGER		              NOT NULL,
  NOM		          NVARCHAR2(50)	          NOT NULL,
  ADRECA	        NVARCHAR2(50),
  TELEFON	        CHAR(9 CHAR),
  IDPOBLACIO	    INTEGER		              NOT NULL,
  IDCATEGORIA	    INTEGER		              NOT NULL,
  NIFPROPIETARI	  CHAR(9 CHAR),
  NOMBRECOPSTOP   INTEGER		    DEFAULT 0	NOT NULL,
  SUMAPUNTS	      FLOAT     	  DEFAULT 0	NOT NULL,
  NUMPUNTS	      INTEGER		    DEFAULT 0	NOT NULL,
  MITJA		        FLOAT     		GENERATED ALWAYS AS (
						                    CASE WHEN NUMPUNTS <> 0
       						                   THEN SUMAPUNTS/NUMPUNTS
       						                   ELSE 0
                                END) VIRTUAL,
  NUMVALCLIENTS	  INTEGER		    DEFAULT 0	NOT NULL,
  DATA_ALTA	      INTEGER		              NOT NULL,
  DATA_BAIXA	    INTEGER
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX MOLIVERBES.IDX_EMPRESA ON MOLIVERBES.EMPRESA
(IDEMPRESA)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE MOLIVERBES.EMPRESA ADD (
  CONSTRAINT EMPRESA_PK
  PRIMARY KEY
  (IDEMPRESA)
  USING INDEX MOLIVERBES.IDX_EMPRESA
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.EMPRESA ADD (
  CONSTRAINT EMPRESA_FK1 
  FOREIGN KEY (IDPOBLACIO) 
  REFERENCES MOLIVERBES.POBLACIO (IDPOBLACIO)
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.EMPRESA ADD (
  CONSTRAINT EMPRESA_FK2
  FOREIGN KEY (IDCATEGORIA) 
  REFERENCES MOLIVERBES.CATEGORIA (IDCATEGORIA)
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.EMPRESA ADD (
  CONSTRAINT EMPRESA_FK3
  FOREIGN KEY (DATA_ALTA) 
  REFERENCES MOLIVERBES.T_MES (IDMES)
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.EMPRESA ADD (
  CONSTRAINT EMPRESA_FK4
  FOREIGN KEY (DATA_BAIXA) 
  REFERENCES MOLIVERBES.T_MES (IDMES)
  ENABLE VALIDATE);

/

/*****************************************************************************/
/********************* 9) CREACIO DE TAULA: COLABORADOR **********************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.COLABORADOR
(
  IDCOLABORADOR		INTEGER			    NOT NULL,
  NOMCOLAB		    NVARCHAR2(50)		NOT NULL,
  IDPERFIL		    CHAR(1 CHAR)		NOT NULL,
  ADRECA		      NVARCHAR2(50),
  IDPOBLACIO		  INTEGER,
  TELEFON		      CHAR(9 CHAR),
  MAIL			      NVARCHAR2(30),
  DATA_ALTA		    INTEGER			    NOT NULL,		
  DATA_BAIXA		  INTEGER
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX MOLIVERBES.IDX_COLABORADOR ON MOLIVERBES.COLABORADOR
(IDCOLABORADOR)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE MOLIVERBES.COLABORADOR ADD (
  CONSTRAINT COLABORADOR_PK
  PRIMARY KEY
  (IDCOLABORADOR)
  USING INDEX MOLIVERBES.IDX_COLABORADOR
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.COLABORADOR ADD (
  CONSTRAINT COLABORADOR_FK1 
  FOREIGN KEY (IDPOBLACIO) 
  REFERENCES MOLIVERBES.POBLACIO (IDPOBLACIO)
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.COLABORADOR  ADD (
  CONSTRAINT COLABORADOR_FK2 
  FOREIGN KEY (IDPERFIL) 
  REFERENCES MOLIVERBES.PERFIL (IDPERFIL)
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.COLABORADOR ADD (
  CONSTRAINT COLABORADOR_FK3 
  FOREIGN KEY (DATA_ALTA) 
  REFERENCES MOLIVERBES.T_MES (IDMES)
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.COLABORADOR ADD (
  CONSTRAINT COLABORADOR_FK4 
  FOREIGN KEY (DATA_BAIXA) 
  REFERENCES MOLIVERBES.T_MES (IDMES)
  ENABLE VALIDATE);

/


/*****************************************************************************/
/********************10) CREACIO DE TAULA: EMPRESATIPUSSERVEI *****************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.EMPRESATIPUSSERVEI
(
  IDEMPRESA		    INTEGER		NOT NULL,
  IDTIPUSSERVEI		INTEGER		NOT NULL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX MOLIVERBES.IDX_EMPRESATIPUSSERVEI ON MOLIVERBES.EMPRESATIPUSSERVEI
(IDEMPRESA,IDTIPUSSERVEI)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE MOLIVERBES.EMPRESATIPUSSERVEI ADD (
  CONSTRAINT EMPRESATIPUSSERVEI_PK
  PRIMARY KEY
  (IDEMPRESA,IDTIPUSSERVEI)
  USING INDEX MOLIVERBES.IDX_EMPRESATIPUSSERVEI
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.EMPRESATIPUSSERVEI ADD (
  CONSTRAINT EMPRESATIPUS_FK1 
  FOREIGN KEY (IDEMPRESA) 
  REFERENCES MOLIVERBES.EMPRESA (IDEMPRESA)
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.EMPRESATIPUSSERVEI ADD (
  CONSTRAINT EMPRESATIPUS_FK2 
  FOREIGN KEY (IDTIPUSSERVEI) 
  REFERENCES MOLIVERBES.TIPUSSERVEI (IDTIPUSSERVEI)
  ENABLE VALIDATE);
/


/*****************************************************************************/
/******************* 11) CREACIO DE TAULA: VALORACIOCOLABORADORS *************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.VALORACIOCOLABORADORS
(
  IDVALORACIO		  INTEGER		    NOT NULL,
  IDEMPRESA		    INTEGER		    NOT NULL,
  IDCOLABORADOR   INTEGER		    NOT NULL,
  IDMES			      INTEGER		    NOT NULL,
  PUNTS			      FLOAT     	  NOT NULL,
  COMENTARI       NVARCHAR2(250)
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX MOLIVERBES.IDX_VALORACIOCOLABORADORS ON MOLIVERBES.VALORACIOCOLABORADORS
(IDVALORACIO)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE MOLIVERBES.VALORACIOCOLABORADORS ADD (
  CONSTRAINT VALORACIOCOLABORADORS_PK
  PRIMARY KEY
  (IDVALORACIO)
  USING INDEX MOLIVERBES.IDX_VALORACIOCOLABORADORS
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.VALORACIOCOLABORADORS ADD (
  CONSTRAINT VALCOLABORADOR_FK1 
  FOREIGN KEY (IDEMPRESA) 
  REFERENCES MOLIVERBES.EMPRESA (IDEMPRESA)
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.VALORACIOCOLABORADORS ADD (
  CONSTRAINT VALCOLABORADOR_FK2
  FOREIGN KEY (IDCOLABORADOR) 
  REFERENCES MOLIVERBES.COLABORADOR (IDCOLABORADOR)
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.VALORACIOCOLABORADORS ADD (
  CONSTRAINT VALCOLABORADOR_FK3
  FOREIGN KEY (IDMES) 
  REFERENCES MOLIVERBES.T_MES (IDMES)
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.VALORACIOCOLABORADORS ADD (
  CONSTRAINT VALCOLAB_PUNTS_VALID 
  CHECK (PUNTS>=0 AND PUNTS<=10) 
  ENABLE VALIDATE);
/

/*****************************************************************************/
/******************** 12) CREACION DE TABLA: LOG *****************************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.LOG
(
  IDLOG		    INTEGER			                      NOT NULL,
  DATA		    DATE			     DEFAULT SYSDATE		NOT NULL,
  PROCEDIMENT	NVARCHAR2(50)                     NOT NULL,
  PARAMETRES	NVARCHAR2(300),
  RSP		      NVARCHAR2(150)                    NOT NULL,
  CODIERROR	  INTEGER
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX MOLIVERBES.IDX_LOG ON MOLIVERBES.LOG
(IDLOG)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE MOLIVERBES.LOG ADD (
  CONSTRAINT LOG_PK
  PRIMARY KEY
  (IDLOG)
  USING INDEX MOLIVERBES.IDX_LOG
  ENABLE VALIDATE);

/


/*****************************************************************************/
/******************** 13) CREACIO DE TAULA: DADES_EMPRESA_MES ****************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.DADES_EMPRESA_MES
(
  IDMES		INTEGER		  NOT NULL,
  IDEMPRESA	INTEGER		NOT NULL,
  PUNTS		FLOAT	      NOT NULL,
  DIFINSAEX	FLOAT	    NOT NULL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

CREATE UNIQUE INDEX MOLIVERBES.IDX_DADES_EMP_MES ON MOLIVERBES.DADES_EMPRESA_MES
(IDMES,IDEMPRESA)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE MOLIVERBES.DADES_EMPRESA_MES ADD (
  CONSTRAINT DADES_EMP_MES_PK  
  PRIMARY KEY
  (IDMES,IDEMPRESA)
  USING INDEX MOLIVERBES.IDX_DADES_EMP_MES
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.DADES_EMPRESA_MES ADD (
  CONSTRAINT DADES_EMP_MES_FK1 
  FOREIGN KEY (IDMES) 
  REFERENCES MOLIVERBES.T_MES (IDMES)
  ENABLE VALIDATE,
  CONSTRAINT DADES_EMP_MES_FK2 
  FOREIGN KEY (IDEMPRESA) 
  REFERENCES MOLIVERBES.EMPRESA (IDEMPRESA)
  ENABLE VALIDATE);
/

/*****************************************************************************/
/******************* 14) CREACIO DE TAULA: DADES_POBLACIO_ANY ****************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.DADES_POBLACIO_ANY
(
  IDANY		    INTEGER		            NOT NULL,
  IDPOBLACIO	INTEGER		            NOT NULL,
  SUMAPUNTS	  FLOAT      	DEFAULT 0	NOT NULL,
  NUMPUNTS	  INTEGER		  DEFAULT 0	NOT NULL,
  MITJA		    FLOAT     	GENERATED ALWAYS AS (
						              CASE WHEN NUMPUNTS <> 0
       						             THEN SUMAPUNTS/NUMPUNTS
       						             ELSE 0
                          END) VIRTUAL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

CREATE UNIQUE INDEX MOLIVERBES.IDX_DADES_POBLACIO_ANY ON MOLIVERBES.DADES_POBLACIO_ANY
(IDANY,IDPOBLACIO)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE MOLIVERBES.DADES_POBLACIO_ANY ADD (
  CONSTRAINT DADES_POBLACIO_ANY_PK  
  PRIMARY KEY
  (IDANY,IDPOBLACIO)
  USING INDEX MOLIVERBES.IDX_DADES_POBLACIO_ANY
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.DADES_POBLACIO_ANY ADD (
  CONSTRAINT DADES_POBLACIO_ANY_FK1 
  FOREIGN KEY (IDANY) 
  REFERENCES MOLIVERBES.T_ANY (IDANY)
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.DADES_POBLACIO_ANY ADD (  
  CONSTRAINT DADES_POBLACIO_ANY_FK2 
  FOREIGN KEY (IDPOBLACIO) 
  REFERENCES MOLIVERBES.POBLACIO (IDPOBLACIO)
  ENABLE VALIDATE);
/

/*****************************************************************************/
/******************* 15) CREACIO DE TAULA: DADES_POBLACIO_MES ****************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.DADES_POBLACIO_MES
(
  IDMES		    INTEGER		              NOT NULL,
  IDPOBLACIO	INTEGER		              NOT NULL,
  SUMAPUNTS	  FLOAT	        DEFAULT 0	NOT NULL,
  NUMPUNTS	  INTEGER		    DEFAULT 0	NOT NULL,
  MITJA		    FLOAT      		GENERATED ALWAYS AS (
						                CASE WHEN NUMPUNTS <> 0
       						               THEN SUMAPUNTS/NUMPUNTS
       						               ELSE 0
     						            END) VIRTUAL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

CREATE UNIQUE INDEX MOLIVERBES.IDX_DADES_POBLACIO_MES ON MOLIVERBES.DADES_POBLACIO_MES
(IDMES,IDPOBLACIO)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE MOLIVERBES.DADES_POBLACIO_MES ADD (
  CONSTRAINT DADES_POBLACIO_MES_PK  
  PRIMARY KEY
  (IDMES,IDPOBLACIO)
  USING INDEX MOLIVERBES.IDX_DADES_POBLACIO_MES
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.DADES_POBLACIO_MES ADD (
  CONSTRAINT DADES_POBLACIO_MES_FK1 
  FOREIGN KEY (IDMES) 
  REFERENCES MOLIVERBES.T_MES (IDMES)
  ENABLE VALIDATE);
  
ALTER TABLE MOLIVERBES.DADES_POBLACIO_MES ADD (
  CONSTRAINT DADES_POBLACIO_MES_FK2 
  FOREIGN KEY (IDPOBLACIO) 
  REFERENCES MOLIVERBES.POBLACIO (IDPOBLACIO)
  ENABLE VALIDATE);
/

/*****************************************************************************/
/******************* 16) CREACIO DE TAULA: DADES_COLAB_EMPRESA ***************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.DADES_COLAB_EMPRESA
(
  IDCOLABORADOR	INTEGER		            NOT NULL,
  IDEMPRESA	    INTEGER	 	            NOT NULL,
  SUMA		      FLOAT     	DEFAULT 0	NOT NULL,
  NUMVALS	      INTEGER		  DEFAULT 0	NOT NULL,
  MITJA		      FLOAT     	GENERATED ALWAYS AS (
						                CASE WHEN NUMVALS <> 0
       						               THEN SUMA/NUMVALS
       						               ELSE 0
                            END) VIRTUAL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

CREATE UNIQUE INDEX MOLIVERBES.IDX_DADES_COLAB_EMPRESA ON MOLIVERBES.DADES_COLAB_EMPRESA
(IDCOLABORADOR,IDEMPRESA)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE MOLIVERBES.DADES_COLAB_EMPRESA ADD (
  CONSTRAINT DADES_COLAB_EMPRESA_PK  
  PRIMARY KEY
  (IDCOLABORADOR,IDEMPRESA)
  USING INDEX MOLIVERBES.IDX_DADES_COLAB_EMPRESA
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.DADES_COLAB_EMPRESA ADD (
  CONSTRAINT DADES_COLAB_EMPRESA_FK1 
  FOREIGN KEY (IDCOLABORADOR) 
  REFERENCES MOLIVERBES.COLABORADOR (IDCOLABORADOR)
  ENABLE VALIDATE);
  
ALTER TABLE MOLIVERBES.DADES_COLAB_EMPRESA ADD (
  CONSTRAINT DADES_COLAB_EMPRESA_FK2 
  FOREIGN KEY (IDEMPRESA) 
  REFERENCES MOLIVERBES.EMPRESA (IDEMPRESA)
  ENABLE VALIDATE);
/

/*****************************************************************************/
/************** 17) CREACIO DE TAULA: DADES_PERFIL_EMPRESA_MES ***************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.DADES_PERFIL_EMPRESA_MES
(
  IDPERFIL	CHAR(1 CHAR)	          NOT NULL,
  IDEMPRESA	INTEGER		              NOT NULL,
  IDMES		  INTEGER		              NOT NULL,
  SUMA		  FLOAT     	  DEFAULT 0	NOT NULL,
  NUMVALS	  INTEGER		    DEFAULT 0	NOT NULL,
  MITJA		  FLOAT     		GENERATED ALWAYS AS (
						              CASE WHEN NUMVALS <> 0
       						             THEN SUMA/NUMVALS
       						             ELSE 0
     						          END) VIRTUAL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

CREATE UNIQUE INDEX MOLIVERBES.IDX_DADES_PERFIL_EMPRESA_MES ON MOLIVERBES.DADES_PERFIL_EMPRESA_MES
(IDPERFIL,IDEMPRESA,IDMES)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE MOLIVERBES.DADES_PERFIL_EMPRESA_MES ADD (
  CONSTRAINT DADES_PERFIL_EMPRESA_MES_PK  
  PRIMARY KEY
  (IDPERFIL,IDEMPRESA,IDMES)
  USING INDEX MOLIVERBES.IDX_DADES_PERFIL_EMPRESA_MES
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.DADES_PERFIL_EMPRESA_MES ADD (
  CONSTRAINT DADES_PERFIL_EMPRESA_MES_FK1 
  FOREIGN KEY (IDPERFIL) 
  REFERENCES MOLIVERBES.PERFIL (IDPERFIL)
  ENABLE VALIDATE);
  
ALTER TABLE MOLIVERBES.DADES_PERFIL_EMPRESA_MES ADD (
  CONSTRAINT DADES_PERFIL_EMPRESA_MES_FK2 
  FOREIGN KEY (IDEMPRESA) 
  REFERENCES MOLIVERBES.EMPRESA (IDEMPRESA)
  ENABLE VALIDATE);
  
ALTER TABLE MOLIVERBES.DADES_PERFIL_EMPRESA_MES ADD (
  CONSTRAINTS DADES_PERFIL_EMPRESA_MES_FK3
  FOREIGN KEY (IDMES)
  REFERENCES MOLIVERBES.T_MES (IDMES)
  ENABLE VALIDATE);
/

/*****************************************************************************/
/************** 18) CREACIO DE TAULA: DADES_PERFIL_MES ***********************/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.DADES_PERFIL_MES
(
  IDPERFIL	CHAR(1 CHAR)	          NOT NULL,
  IDMES		  INTEGER		              NOT NULL,
  SUMA		  FLOAT     	  DEFAULT 0	NOT NULL,
  NUMVALS	  INTEGER		    DEFAULT 0	NOT NULL,
  MITJA		  FLOAT     		GENERATED ALWAYS AS (
						              CASE WHEN NUMVALS <> 0
       						             THEN SUMA/NUMVALS
       						             ELSE 0
     						          END) VIRTUAL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

CREATE UNIQUE INDEX MOLIVERBES.IDX_DADES_PERFIL_MES ON MOLIVERBES.DADES_PERFIL_MES
(IDPERFIL,IDMES)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE MOLIVERBES.DADES_PERFIL_MES ADD (
  CONSTRAINT DADES_PERFIL_MES_PK  
  PRIMARY KEY
  (IDPERFIL,IDMES)
  USING INDEX MOLIVERBES.IDX_DADES_PERFIL_MES
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.DADES_PERFIL_MES ADD (
  CONSTRAINT DADES_PERFIL_MES_FK1 
  FOREIGN KEY (IDPERFIL) 
  REFERENCES MOLIVERBES.PERFIL (IDPERFIL)
  ENABLE VALIDATE);
  
ALTER TABLE MOLIVERBES.DADES_PERFIL_MES ADD (
  CONSTRAINTS DADES_PERFIL_MES_FK2
  FOREIGN KEY (IDMES)
  REFERENCES MOLIVERBES.T_MES (IDMES)
  ENABLE VALIDATE);
/

/*****************************************************************************/
/******************* 16) CREACIO DE TAULA: DADES_COLAB_EMPRESA_MES ***********/
/*****************************************************************************/

CREATE TABLE MOLIVERBES.DADES_COLAB_EMPRESA_MES
(
  IDCOLABORADOR	INTEGER		              NOT NULL,
  IDEMPRESA	    INTEGER		              NOT NULL,
  IDMES		      INTEGER		              NOT NULL,
  SUMA		      FLOAT     	            NOT NULL,
  NUMVALS	      INTEGER		              NOT NULL,
  MITJA		      FLOAT     		GENERATED ALWAYS AS (
						                  CASE WHEN NUMVALS <> 0
       						                 THEN SUMA/NUMVALS
       						                 ELSE 0
                              END) VIRTUAL
)
TABLESPACE GUILD_DATA
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

CREATE UNIQUE INDEX MOLIVERBES.IDX_DADES_COLAB_EMPRESA_MES ON MOLIVERBES.DADES_COLAB_EMPRESA_MES
(IDCOLABORADOR,IDEMPRESA,IDMES)
LOGGING
TABLESPACE GUILD_DATA
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE MOLIVERBES.DADES_COLAB_EMPRESA_MES ADD (
  CONSTRAINT DADES_COLAB_EMPRESA_MES_PK  
  PRIMARY KEY
  (IDCOLABORADOR,IDEMPRESA,IDMES)
  USING INDEX MOLIVERBES.IDX_DADES_COLAB_EMPRESA_MES
  ENABLE VALIDATE);

ALTER TABLE MOLIVERBES.DADES_COLAB_EMPRESA_MES ADD (
  CONSTRAINT DADES_COLAB_EMPRESA_MES_FK1 
  FOREIGN KEY (IDCOLABORADOR) 
  REFERENCES MOLIVERBES.COLABORADOR (IDCOLABORADOR)
  ENABLE VALIDATE);
  
ALTER TABLE MOLIVERBES.DADES_COLAB_EMPRESA_MES ADD (
  CONSTRAINT DADES_COLAB_EMPRESA_MES_FK2 
  FOREIGN KEY (IDEMPRESA) 
  REFERENCES MOLIVERBES.EMPRESA (IDEMPRESA)
  ENABLE VALIDATE);
  
ALTER TABLE MOLIVERBES.DADES_COLAB_EMPRESA_MES ADD (
  CONSTRAINT DADES_COLAB_EMPRESA_MES_FK3 
  FOREIGN KEY (IDMES) 
  REFERENCES MOLIVERBES.T_MES (IDMES)
  ENABLE VALIDATE);

/

/*****************************************************************************/
/*****************************************************************************/
/*                          CREACIO DE SEQUENCIES                           */
/*****************************************************************************/
/*****************************************************************************/
CREATE SEQUENCE MOLIVERBES.SEQ_POBLACIO
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
  
CREATE SEQUENCE MOLIVERBES.SEQ_TIPUSSERVEI
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
  
CREATE SEQUENCE MOLIVERBES.SEQ_CATEGORIA
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
  
CREATE SEQUENCE MOLIVERBES.SEQ_EMPRESA
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
  
CREATE SEQUENCE MOLIVERBES.SEQ_COLABORADOR
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

CREATE SEQUENCE MOLIVERBES.SEQ_ALGORITME
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
  
CREATE SEQUENCE MOLIVERBES.SEQ_LOG
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

CREATE SEQUENCE MOLIVERBES.SEQ_ANY
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

CREATE SEQUENCE MOLIVERBES.SEQ_MES
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
 
CREATE SEQUENCE MOLIVERBES.SEQ_VALORACIO
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

/

  
/*****************************************************************************/
/*****************************************************************************/
/*                     CREACIO DE DESENCADENADORS                            */
/*****************************************************************************/
/*****************************************************************************/

CREATE OR REPLACE TRIGGER MOLIVERBES.TRG_POBLACIO
    Before Insert ON MOLIVERBES.POBLACIO
    For Each Row
Begin
   Select SEQ_POBLACIO.Nextval Into :New.IdPoblacio
   From Dual;
End TRG_POBLACIO;
/

CREATE OR REPLACE TRIGGER MOLIVERBES.TRG_TIPUSSERVEI
    Before Insert ON MOLIVERBES.TIPUSSERVEI
    For Each Row
Begin
   Select SEQ_TIPUSSERVEI.Nextval Into :New.IdTipusSERVEI
   From Dual;
End TRG_TIPUSSERVEI;
/

CREATE OR REPLACE TRIGGER MOLIVERBES.TRG_CATEGORIA
    Before Insert ON MOLIVERBES.CATEGORIA
    For Each Row
Begin
   Select SEQ_CATEGORIA.Nextval Into :New.IdCategoria
   From Dual;
End TRG_CATEGORIA;
/


CREATE OR REPLACE TRIGGER MOLIVERBES.TRG_EMPRESA
    Before Insert ON MOLIVERBES.EMPRESA
    For Each Row
Begin
   Select SEQ_EMPRESA.Nextval Into :New.IdEmpresa
   From Dual;
End TRG_EMPRESA;
/

CREATE OR REPLACE TRIGGER MOLIVERBES.COLABORADOR
    Before Insert ON MOLIVERBES.COLABORADOR
    For Each Row
Begin
   Select SEQ_COLABORADOR.Nextval Into :New.IDColaborador
   From Dual;
End TRG_COLABORADOR;
/

CREATE OR REPLACE TRIGGER MOLIVERBES.TRG_ALGORITME
    Before Insert ON MOLIVERBES.ALGORITME
    For Each Row
Begin
   Select SEQ_ALGORITME.Nextval Into :New.IdAlgoritme
   From Dual;
End TRG_ALGORITME;
/

CREATE OR REPLACE TRIGGER MOLIVERBES.TRG_LOG
    Before Insert ON MOLIVERBES.LOG
    For Each Row
Begin
   Select SEQ_LOG.Nextval Into :New.IdLog
   From Dual;
End TRG_LOG;
/

CREATE OR REPLACE TRIGGER MOLIVERBES.TRG_ANY
    Before Insert ON MOLIVERBES.T_ANY
    For Each Row
Begin
   Select SEQ_ANY.Nextval Into :New.IdAny
   From Dual;
End TRG_ANY;
/

CREATE OR REPLACE TRIGGER MOLIVERBES.TRG_MES
    Before Insert ON MOLIVERBES.T_MES
    For Each Row
Begin
   Select SEQ_MES.Nextval Into :New.IdMes
   From Dual;
End TRG_MES;
/

CREATE OR REPLACE TRIGGER MOLIVERBES.TRG_VALORACIO
    Before Insert ON MOLIVERBES.VALORACIOCOLABORADORS
    For Each Row
Begin
   Select SEQ_VALORACIO.Nextval Into :New.IdValoracio
   From Dual;
End TRG_MES;
/


commit;