/* IMPORTANT: s necessari estar connectat amb l'usuari MOLIVERBES amb password SECRET */
/*            abans d'executar aquest script                                           */


/*******************************************************************************
Nom :     TRG_BD_VALORACIO
Paquet:   TFG_PK_ETL
Funcio:   
********************************************************************************/
CREATE OR REPLACE TRIGGER MOLIVERBES.TRG_BD_VALORACIO
    AFTER INSERT OR UPDATE OR DELETE ON VALORACIOCOLABORADORS
    REFERENCING OLD AS old NEW AS new 
    FOR EACH ROW  

DECLARE
v_idPerfil perfil.idPerfil%Type;

BEGIN

   IF INSERTING THEN
      BEGIN
          SELECT idPerfil INTO v_idPerfil FROM Colaborador
                WHERE idColaborador = :new.idColaborador;
	        UPDATE MOLIVERBES.DADES_PERFIL_EMPRESA_MES
	               SET suma = suma + :new.punts, numVals = numVals+1
	               WHERE idMes = :new.idMes AND idPerfil = v_idPerfil AND idEmpresa = :new.IdEmpresa;
	        IF (SQL%ROWCOUNT = 0) THEN
	            INSERT INTO MOLIVERBES.DADES_PERFIL_EMPRESA_MES (idPerfil, idEmpresa, idMes, suma, numVals)
					                VALUES (v_idPerfil, :new.idEmpresa, :new.IdMes, :new.punts, 1);
	        END IF;

	        UPDATE MOLIVERBES.DADES_PERFIL_MES
	               SET suma = suma + :new.punts, numVals = numVals + 1
	               WHERE idPerfil = v_idPerfil AND idMes = :new.idMes;
	        IF (SQL%ROWCOUNT = 0) THEN
	            INSERT INTO MOLIVERBES.DADES_PERFIL_MES (idPerfil, idMes, suma, numVals)
					                VALUES (v_idPerfil, :new.idMes, :new.punts, 1);
	        END IF;
	        UPDATE MOLIVERBES.DADES_COLAB_EMPRESA_MES
	               SET suma = suma + :new.punts, numVals = numVals+1
	               WHERE idMes = :new.idMes AND idColaborador = :new.idColaborador AND idEmpresa = :new.IdEmpresa;
	        IF (SQL%ROWCOUNT = 0) THEN
	            INSERT INTO MOLIVERBES.DADES_COLAB_EMPRESA_MES (idColaborador, idEmpresa, idMes, suma, numVals)
					                VALUES (:new.idColaborador, :new.idEmpresa, :new.IdMes, :new.punts, 1);
	        END IF;
          
         IF v_idPerfil = 'C' THEN
            UPDATE Empresa SET numValClients = numValClients + 1 WHERE idEmpresa = :new.idEmpresa;
         END IF;

         UPDATE Dades_Colab_empresa SET suma = suma + :new.punts, numVals = numVals + 1
		               WHERE idEmpresa = :new.idEmpresa AND idColaborador = :new.idColaborador;
         IF (SQL%ROWCOUNT=0) THEN
            INSERT INTO Dades_Colab_Empresa (idColaborador, idEmpresa, suma, numVals)
					             VALUES (:new.idColaborador, :new.idEmpresa,:new.punts,1);
         END IF;
         
         UPDATE perfil P SET suma = suma + :new.punts, numVals = numVals + 1 WHERE idPerfil = v_idPerfil;

      END;
   END IF;

   IF UPDATING THEN
      BEGIN
          SELECT idPerfil INTO v_idPerfil FROM Colaborador
                WHERE idColaborador = :new.idColaborador;

	        UPDATE MOLIVERBES.DADES_PERFIL_EMPRESA_MES
	               SET suma = suma - :old.punts + :new.punts
	               WHERE idMes = :new.idMes AND idPerfil = v_idPerfil AND idEmpresa = :new.IdEmpresa;

	        UPDATE MOLIVERBES.DADES_PERFIL_MES
	               SET suma = suma - :old.punts + :new.punts
	               WHERE idMes = :new.idMes AND idPerfil = v_idPerfil;

	        UPDATE MOLIVERBES.DADES_COLAB_EMPRESA_MES
	               SET suma = suma - :old.punts + :new.punts
                 WHERE idMes = :new.idMes AND idColaborador = :new.idColaborador AND idEmpresa = :new.IdEmpresa;

         UPDATE Dades_Colab_empresa SET suma = suma - :old.punts + :new.punts
		               WHERE idEmpresa = :new.idEmpresa AND idColaborador = :new.idColaborador;
         
         
         UPDATE perfil P SET suma = suma -:old.punts + :new.punts WHERE idPerfil = v_idPerfil;

      END;
   END IF;

   IF DELETING THEN
      BEGIN
          SELECT idPerfil INTO v_idPerfil FROM Colaborador
                WHERE idColaborador = :old.idColaborador;

	       UPDATE MOLIVERBES.DADES_PERFIL_EMPRESA_MES
	              SET suma = suma - :old.punts, numVals = numVals-1
	              WHERE idMes = :old.idMes AND idPerfil = v_idPerfil AND idEmpresa = :old.IdEmpresa;

	       UPDATE MOLIVERBES.DADES_PERFIL_MES
	              SET suma = suma - :old.punts, numVals = numVals-1
	              WHERE idMes = :old.idMes AND idPerfil = v_idPerfil;

	       UPDATE MOLIVERBES.DADES_COLAB_EMPRESA_MES
	              SET suma = suma - :old.punts, numVals = numVals-1
	              WHERE idMes = :old.idMes AND idColaborador = :old.idColaborador AND idEmpresa = :old.IdEmpresa;
                
         IF v_idPerfil = 'C' THEN
            UPDATE Empresa SET numValClients = numValClients - 1 WHERE idEmpresa = :new.idEmpresa;
         END IF;

         UPDATE Dades_Colab_empresa SET suma = suma - :old.punts, numVals = numVals - 1
		               WHERE idEmpresa = :old.idEmpresa AND idColaborador = :old.idColaborador;
         
         
         UPDATE perfil P SET suma = suma - :old.punts, numVals = numVals - 1 WHERE idPerfil = v_idPerfil;

      END;
   END IF;
END;

/


/*******************************************************************************
Nom :     PROC_CALCUL_DADES_DW 
Paquet:   TFG_PK_ETL
Funcio:   Obte les dades necessries per a emmagatzemar al Magatzem de Dades
	  un cop finalitzat el mes.
********************************************************************************/
CREATE OR REPLACE PROCEDURE PROC_CALCUL_DADES_DW(
  pIdMes  In   T_MES.IdMes%Type,
  Rsp     Out  Nocopy Varchar2)
IS

Type array_tint is varray(1000) of Integer;
int_array array_tint;

param_input Varchar2(300); 
codi_error  Integer;

total        dades_Empresa_mes.punts%Type;
dif          ValoracioColaboradors.punts%Type;
totalCat     Categoria.punts%Type;
totalCli     ValoracioColaboradors.punts%Type;
totalIns     ValoracioColaboradors.punts%Type;
totalAEx     ValoracioColaboradors.punts%Type;
v_idEmpresa  Empresa.idEmpresa%Type;
v_algoritme  Varchar2(100);
v_Mes        t_mes.Mes%Type;
v_any        t_any.anny%Type;
v_idMes      t_mes.idMes%Type;
v_idAny      t_any.idAny%Type;
v_suma       dades_colab_empresa.suma%Type;
v_numVals    dades_colab_empresa.numVals%Type;
v_numValsCli dades_perfil_empresa_mes.numVals%Type;
v_idPoblacio poblacio.idPoblacio%Type;
num_reg      Integer;
v_TopEmpresa  Empresa.idEmpresa%Type;
v_TopPunts    dades_empresa_mes.punts%Type;

reg_inexistent    exception;
reg_ja_tramitat   exception;
reg_no_finalitzat exception;

CURSOR c_empresa IS
	SELECT DISTINCT idEmpresa FROM ValoracioColaboradors WHERE idMes = pIdMes;

CURSOR c_perfil IS
	SELECT idPerfil FROM perfil;

BEGIN 
   param_input := 'pIdMes= ' || pIdMes;
   Rsp := 'OK';
   v_TopPunts := -1;

-- Noms es pot tramitar un mes si ha finalitzat. Comprovem que no s'intenti tramitar el mes actual
   SELECT EXTRACT(MONTH FROM SYSDATE), EXTRACT(YEAR FROM SYSDATE) INTO v_mes, v_any FROM DUAL;
   SELECT idMes INTO v_idMes FROM T_MES M 
          LEFT OUTER JOIN T_ANY A ON M.idAny = A.idAny
          WHERE A.anny = v_any AND M.mes = v_mes;
   IF v_idMes = pIdMes THEN
           raise reg_no_finalitzat;
   END IF;


-- Comprovem si hi ha valoracions emeses en el mes sollicitat.
   SELECT count(*) INTO num_reg FROM VALORACIOCOLABORADORS WHERE IdMes = pIdMes;
   IF num_reg = 0 THEN
	    raise reg_inexistent;
   END IF;

-- Comprovem si el mes sollicitat ja ha estat tramitat.
   SELECT count(*) INTO num_reg FROM MOLIVERBES.T_MES M WHERE M.IdMes = pIdMes AND M.estat = 'N';
   IF num_reg = 0 THEN
	    raise reg_ja_tramitat; 
   END IF;

-- Marquem el mes com a tramitat
   UPDATE t_mes SET estat = 'S' WHERE idMes = pIdMes;

-- Seleccionem l'algoritme corresponent
   SELECT A.algoritme INTO v_algoritme 
      FROM algoritme A
      LEFT OUTER JOIN t_mes M ON M.idAlgoritme = A.idAlgoritme
      WHERE M.idMes = pIdMes; 

-- 1) A partir de l'algoritme de ccul, la puntuaci per categoria i del valor mig de les valoracions per a cada 
-- perfil/empresa durant el mes corresponent, calculem la puntuaci global de l'empresa durant aquell mes

   FOR curs IN c_empresa LOOP
	     SELECT C.punts INTO totalCat FROM categoria C
              LEFT OUTER JOIN empresa E  ON C.idCategoria = E.idCategoria
              WHERE E.idEmpresa = curs.idEmpresa;
	     BEGIN
          SELECT mitja INTO totalCli FROM Dades_Perfil_Empresa_Mes 
		          WHERE IdPerfil = 'C' AND idEmpresa = curs.idEmpresa AND idMes = pidMes;
       EXCEPTION
          WHEN NO_DATA_FOUND THEN
             totalCli := 0;
       END;
       BEGIN
	        SELECT mitja INTO totalIns FROM Dades_Perfil_Empresa_Mes 
		          WHERE IdPerfil = 'I' AND idEmpresa = curs.idEmpresa AND idMes = pidMes;
	     EXCEPTION
          WHEN NO_DATA_FOUND THEN
             totalIns := 0;
       END;
       BEGIN
          SELECT mitja INTO totalAEx FROM Dades_Perfil_Empresa_Mes 
		          WHERE IdPerfil = 'A' AND idEmpresa = curs.idEmpresa AND idMes = pidMes;
       EXCEPTION
          WHEN NO_DATA_FOUND THEN
             totalAEx := 0;
       END;
	     IF (totalCli = 0) OR (totalIns = 0) OR (totalAEx = 0) THEN
		       total := 0;
		       dif := 0;
	     ELSE
		       EXECUTE IMMEDIATE v_algoritme INTO total USING totalCat,totalCLi, totalIns, totalAEx;
		       SELECT ABS(totalIns-totalAex) INTO dif FROM DUAL;
	     END IF;
	     INSERT INTO dades_empresa_mes (idMes, idEmpresa, punts, difInsAex) VALUES (pidMes, curs.idEmpresa,total,dif);

-- 2) Calculem el valor mig de valoracions per poblacio/mes
	     SELECT idPoblacio INTO v_idPoblacio FROM empresa WHERE idEmpresa = curs.idEmpresa;
	     UPDATE Dades_Poblacio_Mes SET sumaPunts = sumaPunts + total, numPunts = numPunts + 1
	            WHERE idPoblacio = v_idPoblacio AND idMes = pIdMes;
	     IF (SQL%ROWCOUNT = 0) THEN
           INSERT INTO Dades_Poblacio_Mes (idPoblacio, idMes, sumaPunts, numPunts)
				          VALUES (v_idPoblacio, pIdMes, total, 1);
	     END IF;

-- 3) Calculem el valor mig de valoracions per poblacio/any
	     SELECT idAny INTO v_idany FROM T_MES WHERE idMes = pIdMes;
	     UPDATE Dades_Poblacio_Any SET sumaPunts = sumaPunts + total, numPunts = numPunts + 1
              WHERE idPoblacio = v_idPoblacio and idAny = v_idAny;
	     IF (SQL%ROWCOUNT = 0) THEN
	         INSERT INTO Dades_Poblacio_Any (idPoblacio, idAny, sumaPunts, numPunts)
				          VALUES (v_idPoblacio, v_idAny, total, 1);	   
	     END IF; 


-- 4) Calculem la valoraci mitjana de cada empresa
	    UPDATE EMPRESA SET numPunts = numPunts + 1, sumaPunts = sumaPunts + total;

-- Comprovem si s la empresa ms valorada
      IF v_TopPunts < total THEN
         v_TopEmpresa := curs.idEmpresa;
         v_TopPunts := Total;
      END IF;
   END LOOP;

-- 7) L'empresa ms valorada augmenta en 1 el seu camp nombreCopsTop
   UPDATE Empresa SET nombreCopsTop = (nombreCopsTop + 1) WHERE idEmpresa = v_TopEmpresa;


   codi_error := SQLCODE;

  INSERT INTO MOLIVERBES.LOG(PROCEDIMENT, PARAMETRES, RSP, CODIERROR) 
                     VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, codi_error);
  Dbms_output.Put_line(Rsp);
  
  commit;
EXCEPTION
   WHEN reg_no_finalitzat THEN
	    codi_error := SQLCODE;
	    Rsp:= 'ERROR: Mes no finalitzat. Encara no es pot tramitar.';
    	Dbms_output.Put_line(Rsp);
	    Rollback;
	    INSERT INTO MOLIVERBES.LOG(PROCEDIMENT, PARAMETRES, RSP, CODIERROR) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, codi_error); 
	    Commit;
   WHEN reg_inexistent THEN
	    codi_error := SQLCODE;
	    Rsp:= 'ERROR: No hi ha valoracions per a aquest mes';
    	Dbms_output.Put_line(Rsp);
	    Rollback;
	    INSERT INTO MOLIVERBES.LOG(PROCEDIMENT, PARAMETRES, RSP, CODIERROR) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, codi_error); 
	    Commit;
   WHEN reg_ja_tramitat THEN
	    codi_error := SQLCODE;
	    Rsp:= 'ERROR: Mes ja calculat. No es pot recalcular.';
	    Dbms_output.Put_line(Rsp);
	    Rollback;
	    INSERT INTO MOLIVERBES.LOG(PROCEDIMENT, PARAMETRES, RSP, CODIERROR) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, codi_error); 
	    Commit;
   WHEN CURSOR_ALREADY_OPEN THEN
      codi_error := SQLCODE;
	    Rsp:= SUBSTR('ERROR: ' || codi_error ||' ' || SQLERRM ,1,300);
	    Dbms_output.Put_line(Rsp);
	    Rollback;
	    INSERT INTO MOLIVERBES.LOG(PROCEDIMENT, PARAMETRES, RSP, CODIERROR) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, codi_error); 
	    Commit;
   WHEN DUP_VAL_ON_INDEX THEN
	    codi_error := SQLCODE;
	    Rsp:= SUBSTR('ERROR: ' || codi_error ||' ' || SQLERRM ,1,300);
	    Dbms_output.Put_line(Rsp);
	    Rollback;
	    INSERT INTO MOLIVERBES.LOG(PROCEDIMENT, PARAMETRES, RSP, CODIERROR) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, codi_error); 
	    Commit;
   WHEN INVALID_CURSOR THEN
	    codi_error := SQLCODE;
	    Rsp:= SUBSTR('ERROR: ' || codi_error ||' ' || SQLERRM ,1,300);
	    Dbms_output.Put_line(Rsp);
	    Rollback;
	    INSERT INTO MOLIVERBES.LOG(PROCEDIMENT, PARAMETRES, RSP, CODIERROR) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, codi_error); 
	    Commit;
   WHEN NO_DATA_FOUND THEN
	    codi_error := SQLCODE;
	    Rsp:= SUBSTR('ERROR: ' || codi_error ||' ' || SQLERRM ,1,300);
	    Dbms_output.Put_line(Rsp);
	    Rollback;
	    INSERT INTO MOLIVERBES.LOG(PROCEDIMENT, PARAMETRES, RSP, CODIERROR) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, codi_error); 
	    Commit;
   WHEN ROWTYPE_MISMATCH THEN
	    codi_error := SQLCODE;
	    Rsp:= SUBSTR('ERROR: ' || codi_error ||' ' || SQLERRM ,1,300);
	    Dbms_output.Put_line(Rsp);
	    Rollback;
	    INSERT INTO MOLIVERBES.LOG(PROCEDIMENT, PARAMETRES, RSP, CODIERROR) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, codi_error); 
	    Commit;
   WHEN TOO_MANY_ROWS THEN
	    codi_error := SQLCODE;
	    Rsp:= SUBSTR('ERROR: ' || codi_error ||' ' || SQLERRM ,1,300);
	    Dbms_output.Put_line(Rsp);
	    Rollback;
	    INSERT INTO MOLIVERBES.LOG(PROCEDIMENT, PARAMETRES, RSP, CODIERROR) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, codi_error); 
	    Commit;
   WHEN VALUE_ERROR THEN
	    codi_error := SQLCODE;
	    Rsp:= SUBSTR('ERROR: ' || codi_error ||' ' || SQLERRM ,1,300);
	    Dbms_output.Put_line(Rsp);
	    Rollback;
	    INSERT INTO MOLIVERBES.LOG(PROCEDIMENT, PARAMETRES, RSP, CODIERROR) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, codi_error); 
	    Commit;
   WHEN Others THEN
	    codi_error := SQLCODE;
	    Rsp:= SUBSTR('ERROR: ' || codi_error ||' ' || SQLERRM ,1,300);
	    Dbms_output.Put_line(Rsp);
	    Rollback;
	    INSERT INTO MOLIVERBES.LOG(PROCEDIMENT, PARAMETRES, RSP, CODIERROR) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, codi_error); 
	    Commit;
End;
/


commit;