SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   Rsp Varchar2(159);
BEGIN
/*****************************************************************************/
/********************** 1)  TAULA: POBLACIO **********************************/
/*****************************************************************************/

--Acci: Alta
--Resultat: Alta efectuada
PROCINS_BD_POBLACIO('Barcelona', Rsp);
--Acci: Alta amb valor poblacio = NULL
--Resultat: Error de restricci d'integritat
PROCINS_BD_POBLACIO(NULL, Rsp);
--Acci: Modificaci d'una poblaci existent
--Resultat: Modificaci efectuada
PROCUPD_BD_POBLACIO(57, 'Tarragona', Rsp);
--Acci: Modificaci d'una poblaci inexistent
--Resultat: Salta excepci reg_inexistent
PROCUPD_BD_POBLACIO(557, 'Tarragona', Rsp);
--Acci: Eliminaci d'una poblaci existent i no relacionada
--Resultat: Eliminaci efectuada
PROCDEL_BD_POBLACIO(57, Rsp);
--Acci: Eliminaci d'una poblaci inexistent
--Resultat: Salta excepci reg_inexistent
PROCDEL_BD_POBLACIO(557, Rsp);
--Acci: Eliminaci d'una poblaci relacionada.
--Resultat: Error de restricci d'integritat
PROCDEL_BD_POBLACIO(50, Rsp);

/*****************************************************************************/
/********************** 2)  TAULA: CATEGORIA *********************************/
/*****************************************************************************/

--Acci: Alta
--Resultat: Alta efectuada
PROCINS_BD_CATEGORIA('4 estrelles Michelin',6,1, Rsp);
--Acci: Modificaci d'una categoria existent
--Resultat: Modificaci efectuada
PROCUPD_BD_CATEGORIA(6,'5 estrelles Michelin',7,2, Rsp);
--Acci: Modificaci d'una categoria inexistent
--Resultat: Salta excepci reg_inexistent
PROCUPD_BD_CATEGORIA(557, '5 estrelles Michelin',7,2, Rsp);
--Acci: Eliminaci d'una categoria existent i no relacionada
--Resultat: Eliminaci efectuada
PROCDEL_BD_CATEGORIA(6, Rsp);
--Acci: Eliminaci d'una categoria inexistent
--Resultat: Salta excepci reg_inexistent
PROCDEL_BD_CATEGORIA(100, Rsp);
--Acci: Eliminaci d'una categoria relacionada.
--Resultat: Error de restricci d'integritat
PROCDEL_BD_CATEGORIA(5, Rsp);

/*****************************************************************************/
/********************** 3)  TAULA: TIPUSSERVEI ********************************/
/*****************************************************************************/

--Acci: Alta
--Resultat: Alta efectuada
PROCINS_BD_TIPUSSERVEI('SERVEI rpida',Rsp);
--Acci: Modificaci d'un tipus de SERVEI existent
--Resultat: Modificaci efectuada
PROCUPD_BD_TIPUSSERVEI(43,'Menjar rpid','N', Rsp);
--Acci: Modificaci d'un tipus de SERVEI inexistent
--Resultat: Salta excepci reg_inexistent
PROCUPD_BD_TIPUSSERVEI(100,'Menjar rpid','N', Rsp);
--Acci: Eliminaci d'un tipus de SERVEI existent i no relacionat
--Resultat: Eliminaci efectuada
PROCDEL_BD_TIPUSSERVEI(43, Rsp);
--Acci: Eliminaci d'un tipus de SERVEI inexistent
--Resultat: Salta excepci reg_inexistent
PROCDEL_BD_TIPUSSERVEI(100, Rsp);
--Acci: Eliminaci d'un tipus de SERVEI relacionat.
--Resultat: Error de restricci d'integritat
PROCDEL_BD_TIPUSSERVEI(2, Rsp);

/*****************************************************************************/
/********************** 4)  TAULA: PERFIL ************************************/
/*****************************************************************************/

--Acci: Alta
--Resultat: Alta efectuada
PROCINS_BD_PERFIL('X','Inspector internac.',Rsp);
--Acci: Modificaci d'un perfil existent
--Resultat: Modificaci efectuada
PROCUPD_BD_PERFIL('X','Insp. internacional', Rsp);
--Acci: Modificaci d'un perfil inexistent
--Resultat: Salta excepci reg_inexistent
PROCUPD_BD_PERFIL('Z','Insp. internacional', Rsp);
--Acci: Eliminaci d'un perfil existent i no relacionat
--Resultat: Eliminaci efectuada
PROCDEL_BD_PERFIL('X', Rsp);
--Acci: Eliminaci d'un perfil inexistent
--Resultat: Salta excepci reg_inexistent
PROCDEL_BD_PERFIL('Z', Rsp);
--Acci: Eliminaci d'un perfil relacionat.
--Resultat: Error de restricci d'integritat
PROCDEL_BD_PERFIL('A', Rsp);

/*****************************************************************************/
/********************** 5)  TAULA: EMPRESA ***********************************/
/*****************************************************************************/

--Acci: Alta
--Resultat: Alta efectuada
PROCINS_BD_EMPRESA('McDonald''s','C/ Llarg, 37', '931234567',10,5,'12345678Z',Rsp);
--Acci: Modificaci d'una empresa existent
--Resultat: Modificaci efectuada
PROCUPD_BD_EMPRESA(379,'Burguer King','C/ Llarg, 37', '931234567',10,5,'12345678Z', Rsp);
--Acci: Baixa d'una empresa inexistent
--Resultat: Salta excepci reg_inexistent
PROCUPD_BD_EMPRESA(500,'Burguer King','C/ Llarg, 37', '931234567',10,5,'12345678Z', Rsp);
--Acci: Baixa d'una empresa existent i no de baixa
--Resultat: Baixa efectuada
PROCDEL_BD_EMPRESA(379, Rsp);
--Acci: Baixa d'una empresa inexistent
--Resultat: Salta excepci reg_inexistent
PROCDEL_BD_EMPRESA(400, Rsp);
--Acci: Modificaci d'una empresa ja de baixa.
--Resultat: Salta excepci reg_ja_baixa
PROCUPD_BD_EMPRESA(379,'Burguer King','C/ Llarg, 37', '931234567',10,5,'12345678Z', Rsp);

/*****************************************************************************/
/********************** 5)  TAULA: COLABORADOR *******************************/
/*****************************************************************************/

--Acci: Alta
--Resultat: Alta efectuada
PROCINS_BD_COLABORADOR('Joan Bailac Ramis','C',null,10,null,'joan@bailac.es',Rsp);
--Acci: Modificaci d'un collaborador existent
--Resultat: Modificaci efectuada
PROCUPD_BD_COLABORADOR(172,'Joana Bailac Ramis',null,10,null,'joana@bailac.es', Rsp);
--Acci: Modificaci d'un collaborador inexistent
--Resultat: Salta excepci reg_inexistent
PROCUPD_BD_COLABORADOR(300,'Joana Bailac Ramis',null,10,null,'joana@bailac.es', Rsp);
--Acci: Baixa d'un collaborador existent i no de baixa
--Resultat: Baixa lgica efectuada
PROCDEL_BD_COLABORADOR(172, Rsp);
--Acci: Baixa d'un collaborador inexistent
--Resultat: Salta excepci reg_inexistent
PROCDEL_BD_COLABORADOR(400, Rsp);
--Acci: Baixa d'un collaborador ja de baixa.
--Resultat: Salta excepci reg_ja_baixa
PROCDEL_BD_COLABORADOR(172, Rsp);
--Acci: Modificaci d'un collaborador existent i de baixa
--Resultat: Salta excepci reg_ja_baixa
PROCUPD_BD_COLABORADOR(172,'Joana Bailac Ramis',null,10,null,'joana@bailac.es', Rsp);

/*****************************************************************************/
/********************** 6)  TAULA: EMPRESATIPUSSERVEI *************************/
/*****************************************************************************/

--Acci: Alta
--Resultat: Alta efectuada
PROCINS_BD_EMPRESATIPUSSERVEI(20,40,Rsp);
PROCINS_BD_EMPRESATIPUSSERVEI(379,40,Rsp);
--Acci: Alta amb dades inexistents
--Resultat: Salta excepci reg_inexistent
PROCINS_BD_EMPRESATIPUSSERVEI(500,40,Rsp);
--Acci: Alta ja existent
--Resultat: Salta excepci DUP_VAL_ON_INDEX
PROCINS_BD_EMPRESATIPUSSERVEI(20,40,Rsp);
--Acci: Eliminaci d'una relaci empresa/tipus SERVEI
--Resultat: Eliminaci efectuada
PROCDEL_BD_EMPRESATIPUSSERVEI(7,5, Rsp);
--Acci: Eliminaci d'una relaci empresa/tipus SERVEI inexistent
--Resultat: Salta excepci reg_inexistent
PROCDEL_BD_EMPRESATIPUSSERVEI(7,40, Rsp);

/*****************************************************************************/
/********************** 7)  TAULA: T_ANY *************************************/
/*****************************************************************************/

--Acci: Alta
--Resultat: Alta efectuada
PROCINS_BD_ANY(2017,Rsp);
PROCINS_BD_ANY(2018,Rsp);
--Acci: Modificaci d'un any existent i no relacionat
--Resultat: Modificaci efectuada
PROCUPD_BD_ANY(6,2016,Rsp);
--Acci: Modificaci d'un any existent i relacionat
--Resultat: Salta excepci reg_ja_tramitat
PROCUPD_BD_ANY(1,2016,Rsp);
--Acci: Modificaci d'un any inexistent
--Resultat: Salta excepci reg_inexistent
PROCUPD_BD_ANY(10,2010,Rsp);
--Acci: Eliminaci d'un any existent
--Resultat: Eliminaci efectuada
PROCDEL_BD_ANY(5, Rsp);
--Acci: Eliminaci d'un any inexistent
--Resultat: Salta excepci reg_inexistent
PROCDEL_BD_ANY(10, Rsp);

/*****************************************************************************/
/********************* 8)  TAULA: T_MES **************************************/
/*****************************************************************************/

--Acci: Alta
--Resultat: Alta efectuada
PROCINS_BD_MES(2,4,2,Rsp);
--Acci: Modificaci d'un mes existent i no tramitat
--Resultat: Modificaci efectuada
PROCUPD_BD_MES(38,3,Rsp);
--Acci: Modificaci d'un mes existent i tramitat
--Resultat: Salta excepci reg_ja_tramitat
PROCUPD_BD_MES(1,3,Rsp);
--Acci: Modificaci d'un mes inexistent
--Resultat: Salta reg_inexistent
PROCUPD_BD_MES(50,3,Rsp);
--Acci: Eliminaci d'un mes existent i relacionat
--Resultat: Salta restricci d'integritat
PROCDEL_BD_MES(1, Rsp);
--Acci: Eliminaci d'un mes existent i no relacionat
--Resultat: Eliminaci efectuada
PROCDEL_BD_MES(38, Rsp);
--Acci: Eliminaci d'un mes inexistent
--Resultat: Salta excepci reg_inexistent
PROCDEL_BD_MES(100, Rsp);


/*****************************************************************************/
/********************* 9)  TAULA: VALORACIOCOLABORADORS **********************/
/*****************************************************************************/

--Acci: Alta
--Resultat: Alta efectuada
PROCINS_BD_VALORACIOCOLAB(1,1,37,5,'Ho recomano',Rsp);
--Acci: Alta amb dades inexistents
--Resultat: Salta excepci NO_DATA_FOUND
PROCINS_BD_VALORACIOCOLAB(1,1000,37,5,'Ho recomano',Rsp);
--Acci: Alta amb puntuaci no permesa
--Resultat: Error de restricci d'integritat
PROCINS_BD_VALORACIOCOLAB(1,1,37,50,'Ho recomano.',Rsp);
--Acci: Modificaci d'una valoraci existent i no tramitada
--Resultat: Modificaci efectuada
PROCUPD_BD_VALORACIOCOLAB(1441,6,'No ho recomano',Rsp);
--Acci: Modificaci d'una valoraci inexistent
--Resultat: Salta excepci reg_inexistent
PROCUPD_BD_VALORACIOCOLAB(1500,5,'No ho recomano.',Rsp);
--Acci: Modificaci d'una valoraci ja tramitada
--Resultat: Salta excepci reg_ja_tramitat
PROCUPD_BD_VALORACIOCOLAB(500,6,'No ho recomano.',Rsp);
--Acci: Eliminaci d'una valoraci existent i no tramitada
--Resultat: Eliminaci efectuada
PROCDEL_BD_VALORACIOCOLAB(1441, Rsp);
--Acci: Eliminaci d'una valoraci inexistent
--Resultat: Salta excepci reg_inexistent
PROCDEL_BD_VALORACIOCOLAB(1500, Rsp);
--Acci: Eliminaci d'una valoraci existent i tramitada
--Resultat: Salta excepci reg_ja_tramitat
PROCDEL_BD_VALORACIOCOLAB(500, Rsp);

/*****************************************************************************/
/********************** 6)  TAULA: ALGORITME *********************************/
/*****************************************************************************/

--Acci: Alta
--Resultat: Alta efectuada
PROCINS_BD_ALGORITME('SELECT ((:1 + :2 + :3 + :4)/4) FROM DUAL',Rsp);
--Acci: Modificaci d'un algoritme existent i no utilitzat en cap clcul
--Resultat: Modificaci efectuada
PROCUPD_BD_ALGORITME(4,'SELECT (ABS(:1 - (:2 + :3 + :4))) FROM DUAL',Rsp);
--Acci: Modificaci d'un algoritme inexistent
--Resultat: Salta excepci reg_inexistent
PROCUPD_BD_ALGORITME(10,'SELECT (ABS(:1 - (:2 + :3 + :4))) FROM DUAL',Rsp);
--Acci: Modificaci d'un algoritme existent i ja utilitzat en un clcul
--Resultat: Salta excepci reg_ja_tramitat
PROCUPD_BD_ALGORITME(1,'SELECT (ABS(:1 - (:2 + :3 + :4))) FROM DUAL',Rsp);
--Acci: Eliminaci d'un algoritme existent i no utilitzat en cap clcul
--Resultat: Eliminaci efectuada
PROCDEL_BD_ALGORITME(4, Rsp);
--Acci: Eliminaci d'un algoritme inexistent
--Resultat: Salta excepci reg_inexistent
PROCDEL_BD_ALGORITME(10, Rsp);
--Acci: Eliminaci d'un algoritme existent i ja utilitzat en un clcul.
--Resultat: Salta excepci mes_ja_tramitat
PROCDEL_BD_ALGORITME(1, Rsp);


END;