SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   Rsp Varchar2(159);
BEGIN
/*****************************************************************************/
/***Funci: Llista la puntuaci mensual de cada empresa de restauraci********/
/*****************************************************************************/

-- Acci: LListat sense parmetres
-- Resultat: Mostra el llistat
PROC_PUNTS_EMPRESA(Rsp);
/*****************************************************************************/
/***Funci: Donada una ciutat i un mes, llistat de totes les empreses de******/
/***        restauraci d'aquella ciutat que la seva valoraci estigui *******/
/***        entre les 10 millors d'aquell mes, ordenades de forma descendent */
/*****************************************************************************/

-- Acci: Llistat de ciutat sense registres
-- Resultat: Salta excepci no_reg_trobats
PROC_PUNTS_MES_POBLACIO(1,20,Rsp);
-- Acci: Llistat de mes sense registres
-- Resultat: Salta excepci no_reg_trobats
PROC_PUNTS_MES_POBLACIO(36,1,Rsp);
-- Acci: Llistat de mes i poblaci correctes, per amb menys de 10 registres
-- Resultat: Mostra el llistat
PROC_PUNTS_MES_POBLACIO(22,2,Rsp);
-- Acci: Llistat de mes i poblaci correctes, amb ms de 10 registres
-- Resultat: Mostra el llistat
PROC_PUNTS_MES_POBLACIO(1,42,Rsp);

/*****************************************************************************/
/***Funcio:    Llistat de les 10 empreses de restauraci en les que, en ******/
/***           el mes anterior a l'actual, sigui ms gran la diferncia ******/
/***      	   de valoraci dels inspetors del gremi i la mitjana de *********/
/***           valoraci rebuda per les apliacions de valoraci externes. ****/
/*****************************************************************************/

-- Acci: LListat sense parmetres
-- Resultat: Mostra el llistat

PROC_DIFERENCIA_INS_AEX(Rsp);

/*****************************************************************************/
/***Funcio:    Empresa de restauraci que ha estat ms mesos com la **********/
/***           ms valorada **************************************************/
/*****************************************************************************/

-- Acci: LListat sense parmetres
-- Resultat: Mostra el llistat
PROC_TOPEMPRESA(Rsp);

/*****************************************************************************/
/***Funcio:    Valoraci mitjana que fan els clients registrats **************/
/*****************************************************************************/

-- Acci: LListat sense parmetres
-- Resultat: Mostra el llistat
PROC_MITJA_CLIENTS(Rsp);

/*****************************************************************************/
/***Funcio:    Valor mig de les valoracions de totes les empreses de *********/
/***           restauraci d'una poblaci i any ******************************/
/*****************************************************************************/

-- Acci: Llistat de ciutat sense registres
-- Resultat: Salta excepci no_reg_trobats
PROC_MITJA_ANY_POBLACIO(1,20,Rsp);
-- Acci: Llistat d'un any sense registres
-- Resultat: Salta excepci no_reg_trobats
PROC_MITJA_ANY_POBLACIO(4,1,Rsp);
-- Acci: Llistat d'any i poblaci correctes, per amb menys de 10 registres
-- Resultat: Mostra el llistat
PROC_MITJA_ANY_POBLACIO(22,2,Rsp);
-- Acci: Llistat de mes i poblaci correctes, amb ms de 10 registres
-- Resultat: Mostra el llistat
PROC_MITJA_ANY_POBLACIO(1,42,Rsp);

/*****************************************************************************/
/***Funcio:    TOP-10 d'empreses de restauraci pel que fa al nmero de ******/
/***           valoracions entrades per clients ******************************/
/*****************************************************************************/

-- Acci: LListat sense parmetres
-- Resultat: Mostra el llistat
PROC_NUM_VALOR_CLIENTS(Rsp);

/*****************************************************************************/
/***Funcio:    Valoraci mitjana de totes les empreses de restauraci per ****/
/***           cada ciutat i mes. ********************************************/
/*****************************************************************************/

-- Acci: LListat sense parmetres
-- Resultat: Mostra el llistat
PROC_MITJA_POBLACIO_MES(Rsp);

/*****************************************************************************/
/***Funcio:    TOP5 Inspectors pel que va a la seva puntuaci mitjana per ****/
/***           empresa *******************************************************/
/*****************************************************************************/

-- Acci: LListat sense parmetres
-- Resultat: Mostra el llistat
PROC_MITJA_INSPECTOR_EMPRESA(Rsp);

/*****************************************************************************/
/***Funcio:    TOP10 d'empreses de restauraci pel que fa al valor de ********/
/***           valoracions per a cada categoria i tipologia d'empresa. *******/
/*****************************************************************************/

-- Acci: LListat sense parmetres
-- Resultat: Mostra el llistat
PROC_MITJA_CATEGORIA_TIPUS(Rsp);

END;